summaryrefslogtreecommitdiffstats
path: root/gettext-tools/tests/format-c-2
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2003-02-14 14:33:59 +0000
committerBruno Haible <bruno@clisp.org>2009-06-23 12:09:42 +0200
commit1bc6c53d2a10dabab491838c0fea05b89559efaa (patch)
tree4b302fe7e717d8067db99e4a6359b32dc9cc0368 /gettext-tools/tests/format-c-2
parent913de4c14422694b6589f3e53cdead86cd6d039e (diff)
downloadexternal_gettext-1bc6c53d2a10dabab491838c0fea05b89559efaa.zip
external_gettext-1bc6c53d2a10dabab491838c0fea05b89559efaa.tar.gz
external_gettext-1bc6c53d2a10dabab491838c0fea05b89559efaa.tar.bz2
Move tests/format-c-2 to gettext-tools/tests/format-c-2.
Diffstat (limited to 'gettext-tools/tests/format-c-2')
-rwxr-xr-xgettext-tools/tests/format-c-2187
1 files changed, 187 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-c-2 b/gettext-tools/tests/format-c-2
new file mode 100755
index 0000000..4827e34
--- /dev/null
+++ b/gettext-tools/tests/format-c-2
@@ -0,0 +1,187 @@
+#! /bin/sh
+
+# Test checking of C format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-c-2.data"
+cat <<\EOF > f-c-2.data
+# Valid: %% doesn't count
+msgid "abc%%def"
+msgstr "xyz"
+# Invalid: invalid msgstr
+msgid "abc%%def"
+msgstr "xyz%"
+# Valid: same arguments
+msgid "abc%s%gdef"
+msgstr "xyz%s%g"
+# Valid: same arguments, with different widths
+msgid "abc%2sdef"
+msgstr "xyz%3s"
+# Valid: same arguments but in numbered syntax
+msgid "abc%s%gdef"
+msgstr "xyz%1$s%2$g"
+# Valid: permutation
+msgid "abc%s%g%cdef"
+msgstr "xyz%3$c%2$g%1$s"
+# Invalid: too few arguments
+msgid "abc%2$udef%1$s"
+msgstr "xyz%1$s"
+# Invalid: too few arguments
+msgid "abc%sdef%u"
+msgstr "xyz%s"
+# Invalid: too many arguments
+msgid "abc%udef"
+msgstr "xyz%uvw%c"
+# Valid: same numbered arguments, with different widths
+msgid "abc%2$5s%1$4s"
+msgstr "xyz%2$4s%1$5s"
+# Invalid: missing argument
+msgid "abc%2$sdef%1$u"
+msgstr "xyz%1$u"
+# Invalid: missing argument
+msgid "abc%1$sdef%2$u"
+msgstr "xyz%2$u"
+# Invalid: added argument
+msgid "abc%1$udef"
+msgstr "xyz%1$uvw%2$c"
+# Valid: type compatibility
+msgid "abc%i"
+msgstr "xyz%d"
+# Valid: type compatibility
+msgid "abc%o"
+msgstr "xyz%u"
+# Valid: type compatibility
+msgid "abc%u"
+msgstr "xyz%x"
+# Valid: type compatibility
+msgid "abc%u"
+msgstr "xyz%X"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%E"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%f"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%F"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%g"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%G"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%a"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%A"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%s"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%i"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%o"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%e"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%c"
+msgstr "xyz%n"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%i"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%o"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%e"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%n"
+# Invalid: type incompatibility
+msgid "abc%i"
+msgstr "xyz%o"
+# Invalid: type incompatibility
+msgid "abc%i"
+msgstr "xyz%e"
+# Invalid: type incompatibility
+msgid "abc%i"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%i"
+msgstr "xyz%n"
+# Invalid: type incompatibility
+msgid "abc%u"
+msgstr "xyz%e"
+# Invalid: type incompatibility
+msgid "abc%u"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%u"
+msgstr "xyz%n"
+# Invalid: type incompatibility
+msgid "abc%e"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%e"
+msgstr "xyz%n"
+# Invalid: type incompatibility
+msgid "abc%p"
+msgstr "xyz%n"
+# Invalid: type incompatibility for width
+msgid "abc%g%*g"
+msgstr "xyz%*g%g"
+EOF
+
+: ${MSGFMT=msgfmt}
+n=0
+while read comment; do
+ read msgid_line
+ read msgstr_line
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-c-2-$n.po f-c-2-$n.mo"
+ cat <<EOF > f-c-2-$n.po
+#, c-format
+${msgid_line}
+${msgstr_line}
+EOF
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if ${MSGFMT} --check-format -o f-c-2-$n.mo f-c-2-$n.po; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ ${MSGFMT} --check-format -o f-c-2-$n.mo f-c-2-$n.po 2> /dev/null
+ if test $? = 1; then
+ :
+ else
+ fail=yes
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string checking error:" 1>&2
+ cat f-c-2-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-c-2-$n.po f-c-2-$n.mo
+done < f-c-2.data
+
+rm -fr $tmpfiles
+
+exit 0